Subject: [Tsvwg] Re: [Sigtran] Question on Chunk and Parameters type processing.

From: "Brian F. G. Bidulock" <[email-masked]>
Date: Mon, 14 Mar 2005 13:42:22 -0700

Laxman,

You should post your question to [email-masked], but, each chunk
is independent: they are processed and responded to in order.

--brian

On Mon, 14 Mar 2005, Laxman Bana wrote:

> Hi Everyone,
>    I have couple of questions regarding to the processing of
> chunks/parameters.
> 
> RFC 2960 Section 3.2:
> 
> 1.) This section describes how to handle invalid chunks based on the
> higher-order two bits, but it doesn't describe
> how to handle if multiple SCTP chunks in a packet contains all different
> kinds of action bits?
> 
> 2.) Is it mean the first two bits in a first chunk are meaningful?
>     Or All SCTP chunks in one packet should have the same action bits?
> 
> >From section 3.2.1, I have the same doubts for parameters types within a
> SCTP chunk.
> 
> Please could someone send me a link if the above questions are answered in
> the discussion group. I sincerely thank you in advance.
> 
> Thanks.
> -Laxman
> 
> 
> 
> _______________________________________________
> Sigtran mailing list
> [email-masked]
> https://www1.ietf.org/mailman/listinfo/sigtran

-- 
Brian F. G. Bidulock    ¦ The reasonable man adapts himself to the ¦
[email-masked]    ¦ world; the unreasonable one persists in  ¦
http://www.openss7.org/ ¦ trying  to adapt the  world  to himself. ¦
                        ¦ Therefore  all  progress  depends on the ¦
                        ¦ unreasonable man. -- George Bernard Shaw ¦

_______________________________________________
tsvwg mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/tsvwg

---

From: "Brian F. G. Bidulock" <[email-masked]>
Date: Mon, 14 Mar 2005 15:55:01 -0700

Laxman,

I believe your are overgeneralizing.  Different chunks have different rules
concerning bundling and ordering in packets.  Action bits are consistent
with those rules.  Is there are specific chunk that causes you concern?

--brian

On Mon, 14 Mar 2005, Laxman Bana wrote:

> Brian,
>    Sorry I didn't see you posting my question on [email-masked] and I tried
> to post it again.
> >
> The treatment for the SCTP packet will be different for the same chunks with
> a different order. In this case
> I am not able to see the importance of action bits in chunk type. In first
> case sctp might drop entire packet and in second case it might consume valid
> packet(s).
> 
> -Thanks
> Laxman
> 
> >
> > --brian
> >

---

From: Randall Stewart <[email-masked]>
Date: Tue, 15 Mar 2005 19:32:27 -0500

Brian:

Thanks for forwarding this :-D

Laxman:

I am a bit unclear on your question... You
process SCTP chunks, as Brian said, in the order
they appear in the packet. Control chunks must appear
first BEFORE Data chunks.

Now, depending on bundling you can have different
results... i.e. if you bundled a control
chunk with a drop this chunk and stop processing
indication ahead of another chunk, you would never
reach the second chunk... reverse the order and
you get the first chunk processed and any others
afterwards dropped... this is just how it works.

But thats ok since first of all most extensions use a parameter
in the INIT/INIT-ACK to declare that the feature is supported.
For example PR-SCTP (RFC3758) does this. Second, if for some reason
a "supported extension parameter" is not around, the feature
might be implemented with say an "ignore and continue but report".
This will allow an endpoint to figure out the peer does not support
some feature (when it gets the error report).

Another example is the Authentication chunk. In this case it
is setup to drop and discard. And, this is what you want, since if
you don't understand the AUTH chunk, then you can't authenticate
the subsequent chunks that are desired to be authenticated by the
sender.

Each bit can be used in some respect to cause specific actions
to be done for extensions. Most all the base spec is set to 00 in
the upper bits.. since if you don't understand something in the
base spec you don't understand the protocol :-D

Hope that helps..

R

-- 
Randall Stewart
803-345-0369 <or> 815-342-5222(cell)

---

From: "Laxman Bana" <[email-masked]>
Date: Tue, 15 Mar 2005 19:14:32 -0500

Hello Everyone,
   I got another doubt in similar context. What would be the correct
response if the receiver gets unrecognized chunk
with action bits set to 01 or 11 in COOKIE-WAIT state (no INIT-ACK)? Should
SCTP silently drop the packet or Send an error to the remote?
   I greatly appreciate if you can point out where it is discussed in RFC, I
have been reading it but not able to
get the right text for the above case.

Thanks once again.
-Laxman.

> -----Original Message-----
> From: Brian F. G. Bidulock [mailto:[email-masked]]
> Sent: Monday, March 14, 2005 5:55 PM
> To: Laxman Bana
> Cc: [email-masked]
> Subject: Re: [Sigtran] Question on Chunk and Parameters type processing.
>
>
> Laxman,
>

---

From: "Laxman Bana" <[email-masked]>
Date: Mon, 14 Mar 2005 16:24:37 -0500

Brian,

-Thanks
Laxman

---

From: "Laxman Bana" <[email-masked]>
Date: Tue, 15 Mar 2005 09:56:02 -0500

Brian,
  I see your point, but when I tried to implement action bits the rules were
not clear. It is quite confusing.
I do not have a test case that breaks the rule at this moment.

-Thanks
Laxman.

---

From: Randall Stewart <[email-masked]>
Date: Tue, 22 Mar 2005 12:52:27 -0500

> get the right text for the above case.

First of all you are not established...

Second I must assume the chunk you are "making up" arrives
with the correct v-tag .. aka the one sent in the INIT.

Which means that the peer, having never seen a COOKIE-ECHO, since
you did not send one, must be purposely violating the protocol.

In any event the peer stack is badly badly broken.. in fact
so broken I don't think it matters what the receiving SCTP does silently
drop or send an error...  It IMO is an implementation choice.. .I would
not expect to get very far in the conversation with such a broken stack.

R